// $Id: data.h,v 1.5 1998/06/24 08:19:24 knoll Exp $
#ifndef DATA_H
#define DATA_H

class QFile;
#include <qdict.h>
#include <qstring.h>

#define DATA Data::getData()
 
class Data 
{

public:
  Data();
  ~Data();
  static Data *getData();

  enum { MGETTY, VOICE, SENDFAX };

  const QString readMgettyEntry(const char *key);
  const QString readVoiceEntry(const char *key);
  const QString readVgettyEntry(const char *key);
  const QString readSendfaxEntry(const char *key);
  void writeMgettyEntry(const char *key, const char *value);
  void writeVoiceEntry(const char *key, const char *value);
  void writeVgettyEntry(const char *key, const char *value);
  void writeSendfaxEntry(const char *key, const char *value);
  void writeBack();
  bool readonly();
  void sync();

  int getModemSpeed();
  const char *getModemType();
  const char *getCompression();

protected:
  static Data *dataobject;
  
private:
  void init();
  void readFile(int which);
  bool writeFile(int which);
  void writeRemainingEntries(QFile *, QDict<QString> *);
  bool testWritePermission();

  QDict<QString> *mgettyoptions;
  QDict<QString> *voiceoptions;
  QDict<QString> *vgettyoptions;
  QDict<QString> *sendfaxoptions;

  bool dirty;
  bool readonlyflag;
};

#endif

