// $Id
//
// This class handles vgetty as long as kvoice is running. It is only 
// needed, when vgetty isn't spawned by init
//
#ifndef _GETTYHANDLER_H_
#define _GETTYHANDLER_H_

#include <qobject.h>
#include <time.h>
 
class KProcess;

#define GETTYHANDLER GettyHandler::getGettyHandler()

class GettyHandler : public QObject
{
    Q_OBJECT

public:
    GettyHandler();
    virtual ~GettyHandler();
    
    bool isRunFromInittab();
    const QString getDevice(bool strip=false);
    const QString deviceFromInittab();
    bool writeInittab(QString device);
    bool inittabEntryExists();
    bool start();
    void quit();
    void on();
    void off();

    static GettyHandler *getGettyHandler();

protected:
    void restartGetty();
  
    KProcess *proc;
    static GettyHandler *currentHandler;
    time_t started_at;
    int tries;


public slots:
    void slotGettyHasExited(KProcess *);
    void slotTakeCall();
};

#endif
