// $Id: greetings.h,v 1.6 1998/06/24 08:19:27 knoll Exp $
#ifndef GREETING_H
#define GREETING_H

#include <ktopwidget.h>
#include <qpushbt.h>
#include <qlined.h>
#include <qstring.h>
#include <qframe.h>

#include <kprocess.h>


class Data;
class KConfig;
class KToolBar;
class Messages;
class KVFileDlg;
class KDNDDropZone;
class QDir;
class MessageList;

class Greetings : public KTopLevelWidget
{
  Q_OBJECT


public:
  Greetings(const char *name=0, 
	    Messages *m = 0);
  ~Greetings();
  void readConfig();
  void writeConfig(bool sync = false);

  enum { BUTTON_NEW, 
	 BUTTON_PLAY, 
	 BUTTON_STOP, 
	 BUTTON_DEL,
	 BUTTON_CLOSE };

signals:
  void finished();

public slots:
  void slotFinished();
  void slotPlay();
  void slotStop();
  void slotDelete();
  void slotNew();
  void slotNewFinished();
  void slotImportFile(const char *name);
  void slotRecFromHeadset();
  void slotRecordFinished(KProcess *proc);
  void slotRecordStdout(KProcess *proc, char *buffer, int buflen);
  void slotDrop();
  void slotHelp();
  void slotMessageIsPlayed();
  void slotPlayingFinished();
  void slotMessageHighlighted(int, int);
  void slotMessageSelected(int, int);

private:
  void setupMenuBar();
  void setupToolBar();
  void init();

  void getGreetings();
  bool makeIndex();
  void initNewDialog();

  void setPlay(bool stat); 
  void setStop(bool stat);
  void setDelete(bool stat);

  KToolBar *toolbar;
  MessageList *greetings;
  QDir *greetingDir;
  QLineEdit *entergreeting;
  QString indexfilename;
  QWidget *recorddialog;
  QWidget *view;

  KVFileDlg *filedlg;
  KProcess *proc;
  KDNDDropZone *dropZone;

  Data *data; 
  Messages *messages;
};

#endif

