// $Id: mainwidget.h,v 1.8 1998/08/26 22:11:56 lars Exp $
#ifndef MODEM_H
#define MODEM_H

#include <qpopmenu.h>
#include <qtabdlg.h>
#include <qdir.h>
#include <qlined.h>

#include <kmenubar.h>
#include <ktoolbar.h>
#include <kstatusbar.h>
#include <ktopwidget.h>

class KProcess;
class SendFax;
class Messages;
class Setup;
class Greetings;

class MainWidget : public KTopLevelWidget
{
  Q_OBJECT
public:

  MainWidget( const char *name = 0 );
  ~MainWidget();

  enum{ 
      BUTTON_PLAY,  
      BUTTON_STOP, 
      BUTTON_COMMENT,
      BUTTON_SHOW,
      BUTTON_PRINT,
      BUTTON_NEW,
      BUTTON_DELETE,
      BUTTON_GETTY,
      BUTTON_TAKE
      };

  void setPlay(bool);
  void setStop(bool);
  void setComment(bool);
  void setPrint(bool);
  void setDelete(bool);
  void setShow(bool);

  static MainWidget *getMainWidget() { return mainObject; }
 
protected: 
  static MainWidget *mainObject;

public slots:
  void kpppSlot();
  void komSlot();
  void setupSlot();
  void setupFinishedSlot();
  void slotGreeting();
  void slotGreetingExited();
  void slotQuit();
  void slotUnimplemented();
  void slotNewFax();
  void slotShowQueue();
  void slotSendSpooled();
  void slotFaxIsSend(KProcess *proc);
  void slotSendExited();
  void slotToggleGetty(bool on);

private:
  void readConfig();
  void writeConfig(bool sync = false);

  void setupMenuBar();
  void setupToolBar();
  void setupStatusBar();
  void setupMessages();
  
  KMenuBar *menubar;
  KToolBar *toolBar;
  KStatusBar *statusbar;
  Messages *messages;

  Greetings *greetings;
  Setup *setupWindow;
  SendFax *sendfax;

};


#endif
