// $Id: setup.h,v 1.8 1998/08/19 17:59:52 lars Exp $
#ifndef SETUP_H
#define SETUP_H

#include <qtabdlg.h>
#include <qwidget.h>
#include <qlabel.h>
#include <qcombo.h>

class Data;
class QGridLayout;
class QButtonGroup;
class QRadioButton;
class QCheckBox;
class KIntegerLine;
class QLineEdit;

#define SETUP Setup::getSetup()

class Setup : public QTabDialog
{
  Q_OBJECT

public:
  Setup(QWidget* parent=0, const char* name="Setup kvoice");
  ~Setup();
  
  static Setup *getSetup();

  void readConfig();
  void writeConfig(bool sync);


protected:
  void setupModem(void);
  void setupLocations(void);
  void setupGeneral(void);
  void setupVoice(void);
  void setupFax(void);

  static Setup *setupobject;
private:
  void createDialog();
  int getIndex(const QString *value, const char** list);
  QComboBox *addComboRow(QWidget *_parent, QGridLayout *_layout,
			 QString _label, const char *_items[], 
			 QString _current,
			 int _row);
  QLineEdit *addLineEdit(QWidget *_parent, QGridLayout *_layout,
			 QString _label, 
			 QString _current,
			 int _row);
  KIntegerLine *addIntegerLine(QWidget *_parent, QGridLayout *_layout,
			       QString _label,  
			       int _current,
			       int _row);
  bool writeInittab(QString device);

  bool dirty;

  QWidget *wProperties;
  QComboBox *cPort;
  QComboBox *cSpeed;  
  QComboBox *cType;
  QLineEdit *cFaxid;
  KIntegerLine *rings;
  QCheckBox *buttonFax;
  QCheckBox *buttonVoice;
  QCheckBox *buttonData;

  QWidget *wLocations;
  QComboBox *cSpoolDir;
  QComboBox *cVoiceDir;
  QComboBox *cFaxDir;
  QComboBox *cMgettyDir;
  QComboBox *cTmpDir;
  bool oldRunPermanently;
  QString spoolDir;
  QString voiceDir;
  QString faxDir;
  QString mgettyDir;
  QString tmpDir;
  
  QWidget *wGeneral;
  QButtonGroup *soundButtonGrp;
  QRadioButton *buttonSoundCard;
  QRadioButton *buttonHeadSet;
  QRadioButton *buttonInternal;
  KIntegerLine *checkInterval;

  QWidget *wVoice;
  KIntegerLine *beep_freq;
  KIntegerLine *beep_len;


  QWidget *wFax;
public slots:
  void applySettings();

signals:
};

#endif







