// $Id: showfaxqueue.cpp,v 1.2 1998/08/27 19:19:25 lars Exp $

#include "showfaxqueue.moc"
#include "global.h"

#include <qlistbox.h>
#include <kprocess.h>
#include <kiconloader.h>
#include <ksimpleconfig.h>
#include <kapp.h>

ShowQueue::ShowQueue()
  : KTopLevelWidget()
{

  init();
  readQueue();
  show();
}

ShowQueue::~ShowQueue()
{

}

void
ShowQueue::init()
{
  KToolBar *toolbar = new KToolBar(this);
  KIconLoader *loader = kapp->getIconLoader();

  toolbar->insertButton(loader->loadIcon("exit.xpm"), 0,
			SIGNAL(clicked()),this,
			SLOT(slotFinished()),TRUE,i18n("Close"));

  toolbar->insertButton(loader->loadIcon("filedel2.xpm"), 1,
			SIGNAL(clicked()), this,
			SLOT(slotDelete()), TRUE,
			i18n("Delete queued Fax"));
  addToolBar(toolbar);

  queued = new QListBox(this);
  setView(queued, TRUE);
}

void 
ShowQueue::readQueue()
{
    queued->clear();

    KProcess *proc = new KProcess();
    
    gcfg->setGroup("executables");
    proc->setExecutable(gcfg->readEntry("faxq"));
    connect(proc, SIGNAL(processExited(KProcess *)),
	    this, SLOT(slotFinishedReading(KProcess *)) );
    connect(proc, SIGNAL(receivedStdout(KProcess *, char *, int)),
	    this, SLOT(slotReadStdout(KProcess *, char*, int)) );
    buf = "";
    proc->start(KProcess::NotifyOnExit, KProcess::Stdout);
}

void 
ShowQueue::slotReadStdout(KProcess *proc, char *buffer, int buflen)
{
  QString aStr;
  aStr.sprintf("%s",buffer);
  aStr.truncate(buflen);
  buf += aStr;
}

void
ShowQueue::slotFinishedReading(KProcess *proc)
{
  delete proc;

  // now parse the buffer and write it to the tablistbox
  int pos = -1;
  int oldpos = -1;
  while((pos = buf.find("\n",oldpos+1)) != -1)
  {
    queued->insertItem(buf.mid(oldpos+1,pos-oldpos-1));
    oldpos = pos;
  }
}

void 
ShowQueue::slotFinished()
{
  delete this;
}

void 
ShowQueue::slotDelete()
{
    QString entry, cmd;

    entry = queued->text(queued->currentItem());
    entry = entry.left(entry.find("/"));

    gcfg->setGroup("executables");
    cmd = gcfg->readEntry("faxrm");
    cmd += " ";
    cmd += entry;
    
    dropPrivileges();
    system(cmd);
    getPrivileges();

    readQueue();
}
